"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
const node_1 = require("vscode-languageserver/node");
const node_2 = require("vscode-languageserver/node");
const html2pug_1 = require("@volar/html2pug");
function execute(document, sourceFile, connection) {
    const desc = sourceFile.getDescriptor();
    if (!desc.template)
        return;
    const lang = desc.template.lang;
    if (lang !== 'html')
        return;
    const pug = html2pug_1.htmlToPug(desc.template.content) + '\n';
    const newTemplate = `<template lang="pug">` + pug;
    let start = desc.template.loc.start - '<template>'.length;
    const end = desc.template.loc.end;
    const startMatch = '<template';
    while (!document.getText(node_2.Range.create(document.positionAt(start), document.positionAt(start + startMatch.length))).startsWith(startMatch)) {
        start--;
        if (start < 0) {
            throw `Can't find start of tag <template>`;
        }
    }
    const range = node_2.Range.create(document.positionAt(start), document.positionAt(end));
    const textEdit = node_1.TextEdit.replace(range, newTemplate);
    connection.workspace.applyEdit({ changes: { [document.uri]: [textEdit] } });
}
exports.execute = execute;
//# sourceMappingURL=htmlToPug.js.map