import type * as templateGen from '../generators/template_scriptSetup';
import type { Ast as ScriptSetupAst } from '../parsers/scriptSetupAst';
import * as SourceMaps from '../utils/sourceMaps';
export declare function generate(script: null | {
    src?: string;
    content: string;
}, scriptSetup: null | {
    content: string;
}, scriptSetupAst: ScriptSetupAst | undefined, htmlGen: ReturnType<typeof templateGen['generate']> | undefined): {
    getText: () => string;
    getMappings: (sourceRangeParser?: ((data: SourceMaps.TsMappingData, range: SourceMaps.Range) => SourceMaps.Range) | undefined) => SourceMaps.Mapping<SourceMaps.TsMappingData>[];
    addText: (str: string) => {
        start: number;
        end: number;
    };
    addCode: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData, extraSourceRanges?: SourceMaps.Range[] | undefined) => {
        start: number;
        end: number;
    };
    addMapping: (str: string, sourceRange: SourceMaps.Range, mode: SourceMaps.Mode, data: SourceMaps.TsMappingData) => {
        start: number;
        end: number;
    };
    addMapping2: (mapping: SourceMaps.Mapping<SourceMaps.TsMappingData>) => void;
} | undefined;
