import * as html from 'vscode-html-languageservice';
import { Position } from 'vscode-languageserver-types';
import { CompletionContext } from 'vscode-languageserver/node';
import type { TsApiRegisterOptions } from '../types';
export declare const triggerCharacter: {
    typescript: string[];
    html: string[];
    css: string[];
};
export declare const wordPatterns: {
    [lang: string]: RegExp;
};
export declare const vueTags: html.ITagData[];
export declare const eventModifiers: Record<string, string>;
export declare function register({ sourceFiles, tsLanguageService, documentContext, vueHost }: TsApiRegisterOptions): (uri: string, position: Position, context?: CompletionContext | undefined, getNameCase?: {
    tag: () => Promise<'both' | 'kebabCase' | 'pascalCase'>;
    attr: () => Promise<'kebabCase' | 'pascalCase'>;
} | undefined) => Promise<html.CompletionList | undefined>;
