import * as CSS from 'vscode-css-languageservice';
import * as HTML from 'vscode-html-languageservice';
import type * as ts from 'typescript';
import { TextDocument } from 'vscode-css-languageservice';
export declare const html: HTML.LanguageService;
export declare const css: CSS.LanguageService;
export declare const scss: CSS.LanguageService;
export declare const less: CSS.LanguageService;
export declare const pug: {
    parsePugDocument: (doc: CSS.TextDocument) => {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    };
    doComplete: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, pos: import("vscode-languageserver").Position, documentContext: HTML.DocumentContext, options?: HTML.CompletionConfiguration | undefined) => Promise<CSS.CompletionList | undefined>;
    findDocumentHighlights: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, pos: import("vscode-languageserver").Position) => CSS.DocumentHighlight[] | undefined;
    findDocumentLinks: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, docContext: HTML.DocumentContext) => CSS.DocumentLink[];
    format: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, options: import("vscode-languageserver").FormattingOptions) => import("vscode-languageserver").TextEdit[];
    doHover: (docDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, pos: import("vscode-languageserver").Position) => import("vscode-languageserver").Hover | undefined;
    createScanner: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, initialOffset?: number | undefined) => {
        scan: () => HTML.TokenType;
        getTokenType: () => HTML.TokenType;
        getTokenOffset: () => number;
        getTokenLength: () => number;
        getTokenEnd: () => number;
        getTokenText: () => string;
        getTokenError: () => string | undefined;
        getScannerState: () => HTML.ScannerState;
    } | undefined;
    getSelectionRanges: (pugDoc: {
        pugTextDocument: CSS.TextDocument;
        htmlTextDocument: CSS.TextDocument;
        htmlDocument: HTML.HTMLDocument;
        pugCode: string;
        htmlCode: string;
        sourceMap: import("./sourceMaps").SourceMap<undefined>;
        error: {
            code: string;
            msg: string;
            line: number;
            column: number;
            filename: string;
        } | undefined;
    }, posArr: import("vscode-languageserver").Position[]) => import("vscode-languageserver").SelectionRange[];
};
export declare const postcss: CSS.LanguageService;
export declare function getCssLanguageService(lang: string): CSS.LanguageService | undefined;
export declare function getCheapTsService(ts: typeof import('typescript/lib/tsserverlibrary'), code: string): {
    service: ts.LanguageService;
    scriptName: string;
};
export declare function getCheapTsService2(ts: typeof import('typescript/lib/tsserverlibrary'), doc: TextDocument): {
    service: {
        findDefinition: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").LocationLink[];
        findTypeDefinition: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").LocationLink[];
        findReferences: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").Location[];
        prepareRename: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").Range | import("vscode-languageserver").ResponseError<void> | undefined;
        doRename: (uri: string, position: import("vscode-languageserver").Position, newName: string) => import("vscode-languageserver").WorkspaceEdit | undefined;
        getEditsForFileRename: (oldUri: string, newUri: string) => import("vscode-languageserver").WorkspaceEdit | undefined;
        getCodeActions: (uri: string, range: import("vscode-languageserver").Range, context: import("vscode-languageserver").CodeActionContext) => import("vscode-languageserver").CodeAction[] | undefined;
        doCodeActionResolve: (codeAction: import("vscode-languageserver").CodeAction) => import("vscode-languageserver").CodeAction;
        findDocumentHighlights: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").DocumentHighlight[];
        findDocumentSymbols: (uri: string) => import("vscode-languageserver").DocumentSymbol[];
        findWorkspaceSymbols: (uri: string) => import("vscode-languageserver").SymbolInformation[];
        doComplete: (uri: string, position: import("vscode-languageserver").Position, options?: ts.GetCompletionsAtPositionOptions | undefined) => import("vscode-languageserver").CompletionItem[];
        doCompletionResolve: (item: import("vscode-languageserver").CompletionItem, newOffset?: number | undefined) => import("vscode-languageserver").CompletionItem;
        doHover: (uri: string, position: import("vscode-languageserver").Position, documentOnly?: boolean | undefined) => import("vscode-languageserver").Hover | undefined;
        doFormatting: (uri: string, options: import("vscode-languageserver").FormattingOptions, range?: import("vscode-languageserver").Range | undefined) => import("vscode-languageserver").TextEdit[];
        getSignatureHelp: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").SignatureHelp | undefined;
        getSelectionRange: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").SelectionRange | undefined;
        doValidation: (uri: string, options: {
            semantic?: boolean | undefined;
            syntactic?: boolean | undefined;
            suggestion?: boolean | undefined;
            declaration?: boolean | undefined;
        }, cancellationToken?: ts.CancellationToken | undefined) => import("vscode-languageserver").Diagnostic[];
        getFoldingRanges: (uri: string) => import("vscode-languageserver").FoldingRange[];
        getDocumentSemanticTokens: (uri: string, range: import("vscode-languageserver").Range, cancle?: import("vscode-languageserver").CancellationToken | undefined) => [number, number, number, number, number][] | undefined;
        callHierarchy: {
            doPrepare: (uri: string, position: import("vscode-languageserver").Position) => import("vscode-languageserver").CallHierarchyItem[];
            getIncomingCalls: (item: import("vscode-languageserver").CallHierarchyItem) => import("vscode-languageserver").CallHierarchyIncomingCall[];
            getOutgoingCalls: (item: import("vscode-languageserver").CallHierarchyItem) => import("vscode-languageserver").CallHierarchyOutgoingCall[];
        };
        dispose: () => void;
        __internal__: {
            raw: import("typescript/lib/tsserverlibrary").LanguageService;
            host: {
                getImportSuggestionsCache: () => any;
                getCompilationSettings(): ts.CompilerOptions;
                getNewLine?(): string;
                getProjectVersion?(): string;
                getScriptFileNames(): string[];
                getScriptKind?(fileName: string): ts.ScriptKind;
                getScriptVersion(fileName: string): string;
                getScriptSnapshot(fileName: string): ts.IScriptSnapshot | undefined;
                getProjectReferences?(): readonly ts.ProjectReference[] | undefined;
                getLocalizedDiagnosticMessages?(): any;
                getCancellationToken?(): ts.HostCancellationToken;
                getCurrentDirectory(): string;
                getDefaultLibFileName(options: ts.CompilerOptions): string;
                log?(s: string): void;
                trace?(s: string): void;
                error?(s: string): void;
                useCaseSensitiveFileNames?(): boolean;
                readDirectory?(path: string, extensions?: readonly string[] | undefined, exclude?: readonly string[] | undefined, include?: readonly string[] | undefined, depth?: number | undefined): string[];
                readFile?(path: string, encoding?: string | undefined): string | undefined;
                realpath?(path: string): string;
                fileExists?(path: string): boolean;
                getTypeRootsVersion?(): number;
                resolveModuleNames?(moduleNames: string[], containingFile: string, reusedNames: string[] | undefined, redirectedReference: ts.ResolvedProjectReference | undefined, options: ts.CompilerOptions): (ts.ResolvedModule | undefined)[];
                getResolvedModuleWithFailedLookupLocationsFromCache?(modulename: string, containingFile: string): ts.ResolvedModuleWithFailedLookupLocations | undefined;
                resolveTypeReferenceDirectives?(typeDirectiveNames: string[], containingFile: string, redirectedReference: ts.ResolvedProjectReference | undefined, options: ts.CompilerOptions): (ts.ResolvedTypeReferenceDirective | undefined)[];
                getDirectories?(directoryName: string): string[];
                getCustomTransformers?(): ts.CustomTransformers | undefined;
                isKnownTypesPackageName?(name: string): boolean;
                installPackage?(options: ts.InstallPackageOptions): Promise<ts.ApplyCodeActionCommandResult>;
                writeFile?(fileName: string, content: string): void;
                directoryExists?(directoryName: string): boolean;
            };
            getTextDocument: (uri: string) => CSS.TextDocument | undefined;
            getTextDocument2: (uri: string) => CSS.TextDocument | undefined;
        };
    };
    uri: string;
};
